;	Forum Downloader version 1.00 Copyright (C) 2007 by Albu Cristian Laurentiu
;
;	This program is free software; you can redistribute
;	it under the terms of the Open Software License version 2.1.
;
;	For more information send and e-mail to cristian.albu@gmail.com

.386
.model	flat,stdcall
option	casemap:none

include	\masm32\include\windows.inc
include	\masm32\include\user32.inc
include	\masm32\include\kernel32.inc
include	\masm32\include\shell32.inc
include	\masm32\include\ws2_32.inc

includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\shell32.lib
includelib	\masm32\lib\ws2_32.lib

maxretries=10
maxctimeout=2
rdelay=100
maxbufsize=1024*1024
maxbufsize1=1024*1024*10
timeout=60*2

dlgf1		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
dlgsf1		PROTO	:DWORD,:DWORD,:DWORD,:DWORD
getforum	PROTO	:DWORD
getfile		PROTO	:DWORD
get_afile	PROTO	:DWORD,:DWORD,:DWORD
get_topics	PROTO	:DWORD
save_topics	PROTO	:DWORD

foruminfo	struct
	_next		dd	?
	hThread		dd	?
	hSocket		dd	?
	saddr		sockaddr_in	<>
	tables		dd	4096 dup(?)		;max_tr,max_td,level,width
	tdtbl		dd	100 dup(?)
	_addr		db	8192 dup(?)
	_loc		db	8192 dup(?)
	_dns		db	8192 dup(?)
	_file		db	8192 dup(?)
	_save		db	8192 dup(?)
	HTTP_GET	db	8192 dup(?)
	_msg		db	8192 dup(?)
foruminfo	ends

.data?
	hInstance	dd	?
	shbff		BROWSEINFO <>
	nid		NOTIFYICONDATA <>
	lvcol		LV_COLUMN <>
	lvit		LV_ITEM <>
	shbrowseforfolder dd	?
	shgetpathfromidlist dd	?
	cotaskmemfree	dd	?
	shell32		dd	?
	ole32		dd	?
	wsadata		WSADATA	<>
	hIcon		dd	?
	f_info		dd	?
	hDialog		dd	?
	started		db	?

	forums		db	1024 dup(?)
	bread		dd	?
	defdir		db	8192 dup(?)
	fsize		dd	?
	diridx		dd	?
	maxfsize	dd	?
	recvbuf		db	maxbufsize dup(?)
	forum_sim	db	8192 dup(?)
	topic_sim	db	8192 dup(?)
	savef		dd	?
	savet		dd	?
	savei		dd	?
	stbl		dd	?
	savebuf		dd	?
	tblforum	dd	?,?
	tbltopic	dd	?,?
	tbltopicf	dd	?,?
	tblposts	dd	?,?
	fdir		db	8192 dup(?)
	logfile		db	8192 dup(?)
	lsave		db	?
	buftmp		db	65536 dup(?)
	buftmp1		db	65536 dup(?)

.code

include	general.h
include	fsave.h

start:
	lea	edi,forums
	xor	eax,eax
	dec	eax
	mov	ecx,256
	cld
	rep	stosd
	invoke	WSAStartup,101h,addr wsadata
	invoke	GetModuleHandle,0
	mov	hInstance,eax
	invoke	LoadIcon,hInstance,500
	mov	hIcon,eax
	invoke	GetModuleFileName,0,addr logfile,8192
	lea	esi,logfile
	mov	edi,esi
	.while byte ptr[esi]
		.if (byte ptr[esi]=='\')||(byte ptr[esi]=='/')||(byte ptr[esi]=='.')
			mov	edi,esi
		.endif
		inc	esi
	.endw
	.if (byte ptr[edi]!='.')
		mov	edi,esi
	.endif
	mov	eax,'gol.'
	stosd
	mov	al,0
	stosb
	mov	lsave,al
	mov	recvbuf,0
	invoke	DialogBoxParam,hInstance,1010,0,addr dlgf1,0
	mov	esi,savef
	.while esi
		push	dword ptr[esi]
		invoke	GlobalFree,esi
		pop	esi
	.endw
	lea	esi,savei
	.while esi
		push	dword ptr[esi]
		invoke	GlobalFree,esi
		pop	esi
	.endw
	invoke	WSACleanup
	invoke	ExitProcess,0

	include	forum.h
fname	db	0
assume	edi:ptr foruminfo
errdir	db	'[ X ] Error creating directory ',0
down1	db	'* Forum downloaded successfully',0
getforum	PROC	lParam:DWORD
	invoke	GlobalAlloc,GPTR,maxbufsize1
	mov	savebuf,eax
	push	ebp
	mov	tbltopic,0
	mov	tbltopic[4],0
	mov	tbltopicf,0
	mov	tbltopicf[4],0
	mov	tblposts,0
	mov	tblposts[4],0
	mov	edi,lParam
	mov	diridx,1
	invoke	getfile,addr recvbuf
	mov	forum_sim,0
	mov	topic_sim,0
	mov	savef,0
	mov	savet,0
	mov	savei,0
	lea	esi,recvbuf
	.while byte ptr[esi]
		.if byte ptr[esi]=='<'
			mov	eax,[esi+1]
			or	eax,20202020h
			.if eax=='ltit'
			.break
			.endif
		.endif
		inc	esi
	.endw
	lea	edi,defdir
	.while byte ptr[edi]
		inc	edi
	.endw
	.if byte ptr[edi-1]!='\'
		mov	al,'\'
		stosb
	.endif
	.if byte ptr[esi]
		.while (byte ptr[esi]!=0)&&(byte ptr[esi]!='>')
			inc	esi
		.endw
		.if byte ptr[esi]=='>'
			inc	esi
		.endif
		mov	ecx,maxfile
		call	escfile
		mov	eax,dword ptr[edi-4]
		or	eax,20202020h
		.if eax=='xedn'
			mov	ax,word ptr[edi-6]
			or	ax,2020h
			.if ax=='i '
				sub	edi,6
				.while (byte ptr[edi-1]==' ')||(byte ptr[edi-1]==':')||(byte ptr[edi-1]=='-')||(byte ptr[edi-1]=='_')
					dec	edi
				.endw
			.endif
		.endif
		.if byte ptr[edi-1]=='\'
			jmp	_fdir
		.endif
		mov	al,0
		stosb
	.else
_fdir:		mov	eax,'uroF'
		stosd
		mov	ax,'_m'
		stosw
		push	edi
		xor	ecx,ecx
		inc	ecx
		.while 1
			pop	edi
			push	edi
			mov	eax,ecx
			push	ecx
			call	itoa
			mov	al,0
			stosb
			invoke	GetFileAttributes,addr defdir
			pop	ecx
			inc	ecx
			.break .if eax==-1
		.endw
		pop	edx
	.endif
	invoke	CreateDirectory,addr defdir,0
	.if eax==0
		invoke	GetLastError
		.if eax!=ERROR_ALREADY_EXISTS
			lea	edi,buftmp
			push	edi
			lea	edx,errdir
			call	copyedx
			lea	edx,defdir
			call	copyedx
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			invoke	GlobalFree,savebuf
			invoke	CloseHandle,[edi].hThread
			pop	ebp
			invoke	ExitThread,0
		.endif
	.endif
	pop	ebp
	push	ebp
	mov	edi,lParam
	lea	esi,recvbuf
	call	getformat
	pop	ebp
	push	ebp
	mov	edi,lParam
	lea	edx,[edi].tdtbl
	mov	stbl,edx
	lea	ebp,chkdirs
	lea	esi,recvbuf
	call	checkdirs
	pop	ebp
	push	ebp
	mov	edi,lParam
	lea	edx,[edi].tdtbl
	call	scantbl
	pop	ebp
	push	ebp
	mov	edi,lParam
	lea	edx,[edi].tdtbl
	mov	stbl,edx
	lea	ebp,createdirs
	lea	esi,recvbuf
	lea	edx,defdir
	.while byte ptr[edx]
		inc	edx
	.endw
	push	dword ptr[edx]
	push	edx
	call	savedirs
	pop	edx
	pop	dword ptr[edx]
	lea	edx,down1
	call	showmsg
	pop	ebp
	push	ebp
	mov	edi,lParam
	invoke	GlobalFree,savebuf
	invoke	CloseHandle,[edi].hThread
	pop	ebp
	invoke	ExitThread,0
getforum	ENDP


cdir	db	'c:\',0
sh32	db	'shell32.dll',0
o32	db	'ole32.dll',0
shbr	db	'SHBrowseForFolder',0
shgp	db	'SHGetPathFromIDList',0
ctmem	db	'CoTaskMemFree',0
start1	db	'&Start',0
start2	db	'&Pause',0
_pause	db	'*** Paused',13,10,0
nofile	db	'* No address entered',13,10,0
dlgf1	PROC	uses esi edi ebx hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
		invoke	GetWindowText,hDlg,addr buftmp,8192
		mov	nid.cbSize,0
		invoke	SendMessage,hDlg,WM_SETICON,ICON_BIG,hIcon
		invoke	SetWindowText,hDlg,addr buftmp
		mov	started,0
		push	hDlg
		pop	hDialog
		invoke	SendDlgItemMessage,hDlg,100,EM_LIMITTEXT,8192,0
		invoke	SendDlgItemMessage,hDlg,101,EM_LIMITTEXT,8192,0
		invoke	SendDlgItemMessage,hDlg,200,EM_LIMITTEXT,65530,0
		invoke	SetDlgItemText,hDlg,101,addr cdir
		mov	shbrowseforfolder,0
		mov	cotaskmemfree,0
		mov	shell32,0
		mov	ole32,0
		mov	f_info,0
		invoke	SetDlgItemText,hDlg,100,addr fname
	.elseif uMsg==WM_COMMAND
		mov	eax,wParam
		.if ax==2
			.if f_info
				mov	edi,f_info
				invoke	TerminateThread,[edi].hThread,0
				invoke	GlobalFree,f_info
			.endif
			invoke	EndDialog,hDlg,0
		.elseif ax==3
			.if shbrowseforfolder==0
				.if shell32==0
					invoke	LoadLibrary,addr sh32
					mov	shell32,eax
				.endif
				.if shell32
					invoke	GetProcAddress,shell32,addr shbr
					mov	shbrowseforfolder,eax
					invoke	GetProcAddress,shell32,addr shgp
					mov	shgetpathfromidlist,eax
				.endif
			.endif
			.if shbrowseforfolder
				invoke	GlobalAlloc,GPTR,8192
				push	eax
				invoke	GetCurrentDirectory,8192,eax
				mov	eax,hDlg
				mov	shbff.hwndOwner,eax
				push	offset shbff
				call	shbrowseforfolder
				.if eax!=0
					push	eax
					push	offset buftmp
					push	eax
					call	shgetpathfromidlist
					.if cotaskmemfree==0
						.if ole32==0
							invoke	LoadLibrary,addr o32
							mov	ole32,eax
						.endif
						.if eax
							invoke	GetProcAddress,ole32,addr ctmem
							mov	cotaskmemfree,eax
						.endif
					.endif
					pop	eax
					.if cotaskmemfree
						push	eax
						call	cotaskmemfree
					.endif
					invoke	SetDlgItemText,hDlg,101,addr buftmp
				.endif
				pop	eax
				push	eax
				invoke	SetCurrentDirectory,eax
				call	GlobalFree
			.endif
		.elseif ax==4
			mov	nid.cbSize,sizeof nid
			mov	eax,hDlg
			mov	nid.hwnd,eax
			mov	nid.uID,100
			mov	nid.uFlags,NIF_ICON or NIF_MESSAGE or NIF_TIP
			mov	nid.uCallbackMessage,WM_USER+10
			mov	eax,hIcon
			mov	nid.hIcon,eax
			invoke	GetWindowText,hDlg,addr nid.szTip,63
			invoke	Shell_NotifyIcon,NIM_ADD,addr nid
			invoke	ShowWindow,hDlg,SW_HIDE
		.elseif ax==400
			invoke	IsDlgButtonChecked,hDlg,400
			.if eax==BST_CHECKED
				mov	lsave,1
			.else
				mov	lsave,0
			.endif
		.elseif ax==5
			invoke	GlobalAlloc,GPTR,sizeof foruminfo
			mov	edi,eax
			mov	f_info,eax
			push	edi
			invoke	GetDlgItemText,hDlg,100,addr [edi]._addr,8192
			mov	defdir,0
			.if byte ptr[edi]._addr==0
				lea	edx,nofile
				call	showmsg
			.else
				xor	eax,eax
				inc	eax
				.if (recvbuf!=0)&&(fsize!=0)
					invoke	SendDlgItemMessage,hDlg,100,EM_GETMODIFY,0,0
				.endif
				.if eax
					push	edi
					invoke	getfile,addr recvbuf
					pop	edi
				.endif
				.if fsize
					invoke	DialogBoxParam,hInstance,1011,hDlg,addr dlgsf1,edi
				.endif
			.endif
			mov	f_info,0
			call	GlobalFree
			invoke	SendDlgItemMessage,hDlg,100,EM_SETMODIFY,0,0
		.elseif ax==1
			.if started==0
				mov	started,1
				invoke	SetDlgItemText,hDlg,1,addr start2
				invoke	GlobalAlloc,GPTR,sizeof foruminfo
				mov	f_info,eax
				mov	edi,eax
				invoke	GetDlgItemText,hDlg,100,addr [edi]._addr,8192
				invoke	GetDlgItemText,hDlg,101,addr defdir,8192
				invoke	GetWindowText,hDlg,addr buftmp,8192
				lea	edx,[edi]._addr
				push	edi
				lea	edi,buftmp
				xor	ecx,ecx
				.while byte ptr[edi]
					.if byte ptr[edi]==32
						inc	ecx
						.break .if ecx==3
					.endif
					inc	edi
				.endw
				mov	eax,' - '
				stosd
				dec	edi
				call	copyedx
				mov	al,0
				stosb
				invoke	SetWindowText,hDlg,addr buftmp
				pop	edi
				invoke	CreateThread,0,0,addr getforum,edi,0,addr [edi].hThread
				mov	[edi].hThread,eax
				invoke	GetDlgItem,hDlg,3
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,5
				invoke	EnableWindow,eax,0
				invoke	GetDlgItem,hDlg,6
				invoke	EnableWindow,eax,0
			.elseif started==1
				mov	started,2
				invoke	SetDlgItemText,hDlg,1,addr start1
			.else
				mov	started,1
				invoke	SetDlgItemText,hDlg,1,addr start2
			.endif
		.endif
	.elseif uMsg==(WM_USER+10)&&(wParam==100)
		mov	eax,lParam
		.if (eax==WM_LBUTTONUP)||(eax==WM_RBUTTONUP)||(eax==WM_LBUTTONDBLCLK)
			invoke	Shell_NotifyIcon,NIM_DELETE,addr nid
			mov	nid.cbSize,0
			invoke	ShowWindow,hDlg,SW_SHOW
			invoke	BringWindowToTop,hDlg
			invoke	SendDlgItemMessage,hDlg,200,EM_SCROLLCARET,0,0
		.endif
	.endif
	xor	eax,eax
	ret
dlgf1	ENDP

col1	db	'Name',0
col2	db	'Address',0
dlgsf1	PROC	uses esi edi ebx hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	mov	eax,uMsg
	.if eax==WM_INITDIALOG
		invoke	SendDlgItemMessage,hDlg,400,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_ONECLICKACTIVATE or LVS_EX_CHECKBOXES or LVS_EX_FULLROWSELECT,LVS_EX_ONECLICKACTIVATE or LVS_EX_CHECKBOXES or LVS_EX_FULLROWSELECT
		mov	lvcol.imask,LVCF_FMT or LVCF_TEXT or LVCF_WIDTH
		mov	lvcol.fmt,LVCFMT_LEFT
		mov	lvcol.lx,183
		mov	lvcol.pszText,offset col1
		mov	lvcol.cchTextMax,12
		mov	lvcol.iSubItem,0
		invoke	SendDlgItemMessage,hDlg,400,LVM_INSERTCOLUMN,0,addr lvcol
		mov	lvcol.lx,162
		mov	lvcol.pszText,offset col2
		mov	lvcol.cchTextMax,3
		invoke	SendDlgItemMessage,hDlg,400,LVM_INSERTCOLUMN,1,addr lvcol
		push	hDlg
		pop	maxfsize
		push	ebp
		mov	edi,lParam
		mov	tbltopic,0
		mov	tbltopic[4],0
		mov	tbltopicf,0
		mov	tbltopicf[4],0
		mov	tblposts,0
		mov	tblposts[4],0
		mov	edi,lParam
		mov	diridx,1
		mov	forum_sim,0
		mov	topic_sim,0
		mov	savef,0
		mov	savet,0
		mov	savei,0
		mov	edi,lParam
		lea	esi,recvbuf
		call	getformat
		pop	ebp
		push	ebp
		mov	edi,lParam
		lea	edx,[edi].tdtbl
		mov	stbl,edx
		lea	ebp,chkdirs
		lea	esi,recvbuf
		call	checkdirs
		pop	ebp
		push	ebp
		mov	edi,lParam
		lea	edx,[edi].tdtbl
		call	scantbl
		pop	ebp
		push	ebp
		mov	edi,lParam
		lea	edx,[edi].tdtbl
		mov	stbl,edx
		lea	ebp,showdirs
		lea	esi,recvbuf
		lea	edx,defdir
		.while byte ptr[edx]
			inc	edx
		.endw
		call	savedirs
		pop	ebp
	.elseif eax==WM_COMMAND
		mov	eax,wParam
		.if eax==2
			invoke	EndDialog,hDlg,0
		.elseif eax==1
			lea	edi,forums
			invoke	SendDlgItemMessage,hDlg,400,LVM_GETITEMCOUNT,0,0
			xor	ecx,ecx
			mov	edx,eax
			.while ecx<edx
				push	ecx
				push	edx
				invoke	SendDlgItemMessage,hDlg,400,LVM_GETITEMSTATE,ecx,LVIS_STATEIMAGEMASK
				pop	edx
				and	eax,8192
				shr	eax,13
				stosb
				pop	ecx
				inc	ecx
			.endw
			invoke	EndDialog,hDlg,0
		.endif
	.endif
	xor	eax,eax
	ret
dlgsf1	ENDP

http1	db	'GET ',0
http2	db	' HTTP/1.0',13,10,0
http3	db	'Host: ',0
http4	db	'Accept: */*',13,10,0
http5	db	'User-Agent: Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',13,10,0
http6	db	'Connection: Close',13,10,0

_blocking dd	0
wsar	db	'* Downloading file ',0
wsad	db	'* Received ',0
wsas	db	', size: ',0
wsab	db	' bytes',0
wsaerr1	db	'[ X ] Error creating socket, code: ',0
wsaerr2	db	'[ X ] Error resolving ',0
wsaerr2a db	' , code: ',0
wsaerr3	db	'[ X ] Error sending request, code: ',0
wsaerr4	db	'[ X ] Error receiving data, code: ',0
wsaerr5	db	'[ X ] Error connecting to ',0
wsaerr6	db	', code: ',0
wsaerr7	db	'[ X ] Timeout, retrying...',13,10,0
wsaerr7a db	'[ X ] Timeout, operation aborted',13,10,0
wsaerra	db	'. Operation aborted',0
wsaerrr	db	', retrying...',0
httpe1	db	'[ X ] Server error - ',13,10,0
httpe2	db	'[ X ] Not found',13,10,0
httpe3	db	'- Moved to ',0
errd1	db	'[ X ] Error downloading file ',0
errd2	db	'[ X ] The image: ',0
errd2a	db	' contains HTML code in it and was not saved',13,10,0
getfile	PROC	uses esi edi ebx rbuf:DWORD
	local	retries:DWORD,lParam:DWORD
	mov	retries,0
	mov	fsize,0
	mov	lParam,edi
	push	edi
	lea	edi,[edi].saddr
	mov	ecx,sizeof sockaddr_in
	xor	eax,eax
	stosb
	pop	edi
	mov	[edi].saddr.sin_port,80*256
	mov	[edi].saddr.sin_family,AF_INET
	lea	esi,[edi]._addr
	mov	eax,[esi]
	or	eax,20202020h
	.if (eax=='ptth')&&(word ptr[esi+4]=='/:')&&(byte ptr[esi+6]=='/')
		lea	esi,[esi+7]
	.endif
	push	edi
	lea	edi,[edi]._dns
	.while (byte ptr[esi]!=0)&&(byte ptr[esi]!=':')&&(byte ptr[esi]!='/')&&(byte ptr[esi]!='\')
		movsb
	.endw
	mov	al,0
	stosb
	pop	edi
	push	edi
	.if byte ptr[esi]==':'
		inc	esi
		call	atoi
		xchg	al,ah
		mov	[edi].saddr.sin_port,ax
	.endif
	pop	edi
	push	edi
	lea	edi,[edi]._file
	.while byte ptr[esi]
		movsb
	.endw
	mov	al,0
	stosb
	pop	edi
	push	edi
	lea	edi,[edi].HTTP_GET

	lea	edx,http1
	call	copyedx
	push	edi
	mov	edi,[esp+4]
	lea	edx,[edi]._file
	pop	edi
	.if byte ptr[edx]!='/'
		mov	al,'/'
		stosb
	.endif
	call	copyedx
	lea	edx,http2
	call	copyedx
	lea	edx,http3
	call	copyedx
	push	edi
	mov	edi,[esp+4]
	lea	edx,[edi]._dns
	pop	edi
	call	copyedx
	mov	ax,0a0dh
	stosw
	lea	edx,http4
	call	copyedx
	lea	edx,http5
	call	copyedx
	lea	edx,http6
	call	copyedx
	mov	ax,0a0dh
	stosw
	mov	al,0
	stosb
	pop	edi
	invoke	inet_addr,addr [edi]._dns
	.if eax==INADDR_NONE
		invoke	gethostbyname,addr [edi]._dns
		.if eax!=0
			mov	eax,[eax+12]
			mov	eax,[eax]
			mov	eax,[eax]
		.endif
	.endif
	.if eax==0
		push	edi
		lea	edi,[edi]._msg
		push	edi
		lea	edx,wsaerr2
		call	copyedx
		push	edi
		mov	edi,[esp+8]
		lea	edx,[edi]._dns
		pop	edi
		call	copyedx
		lea	edx,wsaerr2a
		call	copyedx
		invoke	WSAGetLastError
		call	itoa
		mov	ax,0a0dh
		stosw
		mov	al,0
		stosb
		pop	edx
		call	showmsg
		invoke	Sleep,1000
		pop	edi
		ret
	.endif
	mov	[edi].saddr.sin_addr,eax
_rtr:	mov	fsize,0
	mov	maxfsize,0
	invoke	socket,PF_INET,SOCK_STREAM,IPPROTO_TCP
	.if eax==INVALID_SOCKET
		push	edi
		lea	edi,[edi]._msg
		push	edi
		lea	edx,wsaerr1
		call	copyedx
		invoke	WSAGetLastError
		call	itoa
		mov	ax,0a0dh
		stosw
		mov	al,0
		stosb
		pop	edx
		call	showmsg
		pop	edi
		ret
	.endif
	mov	[edi].hSocket,eax
	invoke	ioctlsocket,[edi].hSocket,FIONBIO,addr _blocking
	invoke	connect,[edi].hSocket,addr [edi].saddr,sizeof sockaddr_in
	.if eax!=0
		.if retries<maxctimeout
			inc	retries
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr5
			call	copyedx
			push	edi
			mov	edi,[esp+8]
			lea	edx,[edi]._dns
			pop	edi
			call	copyedx
			lea	edx,wsaerr6
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			.if rdelay
				invoke	Sleep,rdelay
			.endif
			jmp	_rtr
		.else
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr5
			call	copyedx
			push	edi
			mov	edi,[esp+8]
			lea	edx,[edi]._dns
			pop	edi
			call	copyedx
			lea	edx,wsaerr6
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			ret
		.endif
	.endif
	xor	ecx,ecx
	.while byte ptr[edi].HTTP_GET[ecx]
		inc	ecx
	.endw
	invoke	send,[edi].hSocket,addr [edi].HTTP_GET,ecx,0
	.if eax==SOCKET_ERROR
		.if retries<maxretries
			inc	retries
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr3
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			lea	edx,wsaerrr
			call	copyedx
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			.if rdelay
				invoke	Sleep,rdelay
			.endif
			jmp	_rtr
		.else
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr3
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			lea	edx,wsaerra
			call	copyedx
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			ret
		.endif
	.endif
	push	edi
	lea	edx,[edi]._addr
	lea	edi,[edi]._msg
	push	edi
	push	edx
	lea	edx,wsar
	call	copyedx
	pop	edx
	call	copyedx
	mov	eax,'... '
	stosd
	mov	ax,0a0dh
	stosw
	mov	al,0
	stosb
	pop	edx
	call	showmsg
	pop	edi
	push	edi
	mov	edx,[edi].hSocket
	mov	[edi]._file,0
	mov	edi,rbuf
	.while 1
		mov	eax,edi
		sub	eax,rbuf
		.if maxfsize
			.break .if eax==maxfsize
		.endif
		assume	edi:ptr fd_set
		push	edx
		mov	[edi].fd_count,1
		mov	[edi].fd_array,edx
		lea	ecx,[edi+100]
		assume	ecx:ptr timeval
		mov	[ecx].tv_sec,timeout
		mov	[ecx].tv_usec,0
		invoke	select,1,edi,0,0,ecx
		pop	edx
		assume	edi:ptr foruminfo
		.if eax==0
			pop	edi
			.if retries<maxretries
				inc	retries
				lea	edx,wsaerr7
				call	showmsg
				invoke	closesocket,[edi].hSocket
				.if rdelay
					invoke	Sleep,rdelay
				.endif
				jmp	_rtr
			.else
				lea	edx,wsaerr7a
				call	showmsg
				invoke	closesocket,[edi].hSocket
				ret
			.endif
		.elseif eax==SOCKET_ERROR
			jmp	recv_err
		.endif
		assume	edx:nothing
		push	edx
		mov	bread,0
		invoke	ioctlsocket,edx,FIONREAD,addr bread
		pop	edx
		.if eax==SOCKET_ERROR
			jmp	recv_err
		.endif
		mov	eax,bread
		.if eax
			push	edx
			invoke	recv,edx,edi,bread,0
			pop	edx
		.endif
		
		.if eax==0
			.if maxfsize
				jmp	recv_err
			.else
				.break
			.endif
		.endif
		.if eax==SOCKET_ERROR
recv_err:		pop	edi
			.if retries<maxretries
				inc	retries
				push	edi
				lea	edi,[edi]._msg
				push	edi
				lea	edx,wsaerr4
				call	copyedx
				invoke	WSAGetLastError
				call	itoa
				lea	edx,wsaerrr
				call	copyedx
				mov	ax,0a0dh
				stosw
				mov	al,0
				stosb
				pop	edx
				call	showmsg
				pop	edi
				invoke	closesocket,[edi].hSocket
				.if rdelay
					invoke	Sleep,rdelay
				.endif
				jmp	_rtr
			.else
				push	edi
				lea	edi,[edi]._msg
				push	edi
				lea	edx,wsaerr4
				call	copyedx
				invoke	WSAGetLastError
				call	itoa
				lea	edx,wsaerra
				call	copyedx
				mov	ax,0a0dh
				stosw
				mov	al,0
				stosb
				pop	edx
				call	showmsg
				pop	edi
				invoke	closesocket,[edi].hSocket
				ret
			.endif
		.endif
		.if edi==rbuf
			mov	ecx,dword ptr[edi]
			or	ecx,20202020h
			.if ecx=='ptth'
				mov	byte ptr[edi+eax],0
				push	eax
				push	edi
				lea	ecx,[edi+4]
				sub	eax,4
				.while byte ptr[ecx]>33
					inc	ecx
					dec	eax
				.endw
				.while byte ptr[ecx]==32
					inc	ecx
					dec	eax
				.endw
				.if byte ptr[ecx]=='3'
					.if eax&80000000h
						xor	eax,eax
					.endif
					mov	edi,ecx
					.while eax
						.if word ptr[edi]==0a0dh
							mov	edx,dword ptr[edi+2]
							or	edx,20202020h
							.if edx=='acol'
								mov	edx,dword ptr[edi+2+4]
								or	edx,20202020h
								.if edx=='noit'
									lea	edx,[edi+2+4+4]
									.while (byte ptr[edx]==':')||(byte ptr[edx]==32)
										inc	edx
									.endw
									push	edx
									pop	edx
									mov	edi,lParam
									push	edi
									lea	edi,[edi]._addr
									xor	ecx,ecx
									push	edi
									.if (byte ptr[edx]=='/')
										push	edx
										push	edi
										mov	edi,[esp+4+4+4+4+4+4]
										lea	edx,[edi]._dns
										pop	edi
										mov	eax,'ptth'
										stosd
										mov	eax,'//:'
										stosd
										dec	edi
										call	copyedx
										pop	edx
									.endif
									.while (byte ptr[edx]>32)&&(ecx<8191)
										mov	al,[edx]
										stosb
										inc	edx
										inc	ecx
									.endw
									mov	al,0
									stosb
									mov	edi,[esp+4+4+4+4]
									invoke	closesocket,[edi].hSocket
									lea	edi,[edi]._msg
									push	edi
									lea	edx,httpe3
									call	copyedx
									mov	edx,[esp+4]
									call	copyedx
									mov	ax,0a0dh
									stosw
									mov	al,0
									stosb
									pop	edx
									call	showmsg
									pop	edx

									pop	edi
									pop	eax
									pop	edi
									mov	edi,lParam
									invoke	getfile,rbuf
									ret
								.endif
							.endif
						.endif
						dec	eax
						inc	edi
					.endw
				.elseif byte ptr[ecx]=='5'
					mov	edx,ecx
					pop	edi
					pop	eax
					pop	edi
					push	edi
					lea	edi,[edi]._msg
					push	edi
					push	edx
					lea	edx,httpe1
					call	copyedx
					pop	edx
					xor	ecx,ecx
					.while (ecx<200)&&(byte ptr[edx]>31)
						mov	al,[edx]
						stosb
						inc	edx
						inc	ecx
					.endw
					mov	ax,0a0dh
					stosw
					mov	al,0
					stosb
					pop	edx
					call	showmsg
					pop	edi
					invoke	closesocket,[edi].hSocket
					ret
				.elseif byte ptr[ecx]=='4'
					pop	edi
					pop	eax
					pop	edi
					lea	edx,httpe2
					call	showmsg
					invoke	closesocket,[edi].hSocket
					ret
				.else
					mov	edi,ecx
					.if eax&80000000h
						xor	eax,eax
					.endif
					push	edx
					.while eax
						.if word ptr[edi]==0a0dh
							mov	edx,dword ptr[edi+2]
							or	edx,20202020h
							.if edx=='tnoc'
								mov	edx,dword ptr[edi+2+4]
								or	edx,202020h
								.if edx=='-tne'
									mov	edx,dword ptr[edi+2+4+4]
									or	edx,202020h
									.if edx=='gnel'
										lea	edx,[edi+2+4+4+4+2]
										.while (byte ptr[edx]==':')||(byte ptr[edx]==32)
											inc	edx
										.endw
										push	eax
										push	esi
										mov	esi,edx
										call	atoi
										pop	esi
										mov	maxfsize,eax
										pop	eax
									.elseif edx=='psid'
										lea	edx,[edi+2+4+4+4+2]
										.while (byte ptr[edx]>31)&&(word ptr[edx]!='"=')
											inc	edx
										.endw
										.if byte ptr[edx]=='='
											lea	edx,[edx+2]
											push	edi
											mov	edi,lParam
											push	eax
											lea	edi,[edi]._file
											.while (byte ptr[edx]!='"')&&(byte ptr[edx]>31)
												mov	al,[edx]
												stosb
												inc	edx
											.endw
											mov	al,0
											stosb
											pop	eax
											pop	edi
										.endif
									.endif
								.endif
							.endif
						.endif
						inc	edi
						dec	eax
					.endw
					pop	edx
				.endif
				pop	edi
				pop	eax
			.endif
		.endif
		.if eax>100000h
			int 3
		.endif
		add	edi,eax
		mov	eax,edi
		sub	eax,rbuf
		.if eax>maxbufsize
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,filesizeerr
			call	copyedx
			mov	eax,maxbufsize
			call	itoa
			lea	edx,filesizeerr1
			call	copyedx
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			.break
		.endif
	.endw
	mov	eax,edi
	sub	eax,rbuf
	pop	edi
	mov	fsize,eax
	invoke	closesocket,[edi].hSocket
	mov	ecx,fsize
	push	esi
	push	edi
	mov	edi,rbuf
	mov	esi,edi
	.while ecx
		.break .if dword ptr[esi]==0a0d0a0dh
		inc	esi
		dec	ecx
	.endw
	.if (dword ptr[esi]==0a0d0a0dh)&&(ecx>=4)
		lodsd
		lea	ecx,[ecx-4]
	.endif
	mov	fsize,ecx
	rep	movsb
	mov	al,0
	stosb
	pop	edi
	pop	esi
	push	edi
	lea	edx,[edi]._addr
	lea	edi,[edi]._msg
	push	edi
	push	edx
	lea	edx,wsad
	call	copyedx
	pop	edx
;	call	copyedx
;	lea	edx,wsas
;	call	copyedx
	push	edi
	mov	edi,[esp+8]
	mov	eax,fsize
	pop	edi
	call	itoa
	lea	edx,wsab
	call	copyedx
	mov	ax,0a0dh
	stosw
	mov	al,0
	stosb
	pop	edx
	call	showmsg
	pop	edi
	ret
getfile	ENDP

get_afile	PROC	uses esi ebx rbuf:DWORD,_edi:DWORD,isimg:DWORD
	local	retries:DWORD,lParam:DWORD,hfile:DWORD
	mov	retries,0
	mov	fsize,0
	mov	hfile,0
	mov	lParam,edi
	push	edi
	lea	edi,[edi].saddr
	mov	ecx,sizeof sockaddr_in
	xor	eax,eax
	stosb
	pop	edi
	mov	[edi].saddr.sin_port,80*256
	mov	[edi].saddr.sin_family,AF_INET
	lea	esi,[edi]._addr
	mov	eax,[esi]
	or	eax,20202020h
	.if (eax=='ptth')&&(word ptr[esi+4]=='/:')&&(byte ptr[esi+6]=='/')
		lea	esi,[esi+7]
	.endif
	push	edi
	lea	edi,[edi]._dns
	.while (byte ptr[esi]!=0)&&(byte ptr[esi]!=':')&&(byte ptr[esi]!='/')&&(byte ptr[esi]!='\')
		movsb
	.endw
	mov	al,0
	stosb
	pop	edi
	push	edi
	.if byte ptr[esi]==':'
		inc	esi
		call	atoi
		xchg	al,ah
		mov	[edi].saddr.sin_port,ax
	.endif
	pop	edi
	push	edi
	lea	edi,[edi]._file
	.while byte ptr[esi]
		movsb
	.endw
	mov	al,0
	stosb
	pop	edi
	push	edi
	lea	edi,[edi].HTTP_GET

	lea	edx,http1
	call	copyedx
	push	edi
	mov	edi,[esp+4]
	lea	edx,[edi]._file
	pop	edi
	.if byte ptr[edx]!='/'
		mov	al,'/'
		stosb
	.endif
	call	copyedx
	lea	edx,http2
	call	copyedx
	lea	edx,http3
	call	copyedx
	push	edi
	mov	edi,[esp+4]
	lea	edx,[edi]._dns
	pop	edi
	call	copyedx
	mov	ax,0a0dh
	stosw
	lea	edx,http4
	call	copyedx
	lea	edx,http5
	call	copyedx
	lea	edx,http6
	call	copyedx
	mov	ax,0a0dh
	stosw
	mov	al,0
	stosb
	pop	edi
	invoke	inet_addr,addr [edi]._dns
	.if eax==INADDR_NONE
		invoke	gethostbyname,addr [edi]._dns
		.if eax!=0
			mov	eax,[eax+12]
			mov	eax,[eax]
			mov	eax,[eax]
		.endif
	.endif
	.if eax==0
		push	edi
		lea	edi,[edi]._msg
		push	edi
		lea	edx,wsaerr2
		call	copyedx
		push	edi
		mov	edi,[esp+8]
		lea	edx,[edi]._dns
		pop	edi
		call	copyedx
		lea	edx,wsaerr2a
		call	copyedx
		invoke	WSAGetLastError
		call	itoa
		mov	ax,0a0dh
		stosw
		mov	al,0
		stosb
		pop	edx
		call	showmsg
		pop	edi
		invoke	Sleep,1000
		mov	edi,_edi
		ret
	.endif
	mov	[edi].saddr.sin_addr,eax
_artr:	mov	fsize,0
	mov	maxfsize,0
	invoke	socket,PF_INET,SOCK_STREAM,IPPROTO_TCP
	.if eax==INVALID_SOCKET
		push	edi
		lea	edi,[edi]._msg
		push	edi
		lea	edx,wsaerr1
		call	copyedx
		invoke	WSAGetLastError
		call	itoa
		mov	ax,0a0dh
		stosw
		mov	al,0
		stosb
		pop	edx
		call	showmsg
		pop	edi
		mov	edi,_edi
		ret
	.endif
	mov	[edi].hSocket,eax
	invoke	ioctlsocket,[edi].hSocket,FIONBIO,addr _blocking
	invoke	connect,[edi].hSocket,addr [edi].saddr,sizeof sockaddr_in
	.if eax!=0
		.if retries<maxctimeout
			inc	retries
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr5
			call	copyedx
			push	edi
			mov	edi,[esp+8]
			lea	edx,[edi]._dns
			pop	edi
			call	copyedx
			lea	edx,wsaerr6
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			.if rdelay
				invoke	Sleep,rdelay
			.endif
			jmp	_artr
		.else
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr5
			call	copyedx
			push	edi
			mov	edi,[esp+8]
			lea	edx,[edi]._dns
			pop	edi
			call	copyedx
			lea	edx,wsaerr6
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			mov	edi,_edi
			ret
		.endif
	.endif
	xor	ecx,ecx
	.while byte ptr[edi].HTTP_GET[ecx]
		inc	ecx
	.endw
	invoke	send,[edi].hSocket,addr [edi].HTTP_GET,ecx,0
	.if eax==SOCKET_ERROR
		.if retries<maxretries
			inc	retries
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr3
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			lea	edx,wsaerrr
			call	copyedx
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			.if rdelay
				invoke	Sleep,rdelay
			.endif
			jmp	_artr
		.else
			push	edi
			lea	edi,[edi]._msg
			push	edi
			lea	edx,wsaerr3
			call	copyedx
			invoke	WSAGetLastError
			call	itoa
			lea	edx,wsaerra
			call	copyedx
			mov	ax,0a0dh
			stosw
			mov	al,0
			stosb
			pop	edx
			call	showmsg
			pop	edi
			invoke	closesocket,[edi].hSocket
			mov	edi,_edi
			ret
		.endif
	.endif
	push	edi
	lea	edx,[edi]._addr
	lea	edi,[edi]._msg
	push	edi
	push	edx
	lea	edx,wsar
	call	copyedx
	pop	edx
	call	copyedx
	mov	eax,'... '
	stosd
	mov	ax,0a0dh
	stosw
	mov	al,0
	stosb
	pop	edx
	call	showmsg
	pop	edi
	push	edi
	mov	[edi]._file,0
	mov	edi,rbuf
	.while 1
		mov	edi,[esp]
		mov	edx,[edi].hSocket
		mov	edi,rbuf
		mov	eax,fsize
		.if maxfsize
			.if eax==maxfsize
				.break
			.endif
		.endif
		assume	edi:ptr fd_set
		push	edx
		mov	[edi].fd_count,1
		mov	[edi].fd_array,edx
		lea	ecx,[edi+100]
		assume	ecx:ptr timeval
		mov	[ecx].tv_sec,timeout
		mov	[ecx].tv_usec,0
		invoke	select,1,edi,0,0,ecx
		pop	edx
		assume	edi:ptr foruminfo
		.if eax==0
			pop	edi
			.if retries<maxretries
				inc	retries
				lea	edx,wsaerr7
				call	showmsg
				invoke	closesocket,[edi].hSocket
				.if rdelay
					invoke	Sleep,rdelay
				.endif
				jmp	_artr
			.else
				lea	edx,wsaerr7a
				call	showmsg
				invoke	closesocket,[edi].hSocket
				mov	edi,_edi
				ret
			.endif
		.elseif eax==SOCKET_ERROR
			jmp	arecv_err
		.endif
		assume	edx:nothing
		push	edx
		mov	bread,0
		invoke	ioctlsocket,edx,FIONREAD,addr bread
		pop	edx
		.if eax==SOCKET_ERROR
			jmp	arecv_err
		.endif
		mov	eax,bread
		.if eax
			push	edx
			invoke	recv,edx,edi,bread,0
			pop	edx
		.endif
		
		.if eax==0
			.if maxfsize
				jmp	arecv_err
			.else
				.break
			.endif
		.endif
		.if eax==SOCKET_ERROR
arecv_err:		pop	edi
			.if retries<maxretries
				inc	retries
				push	edi
				lea	edi,[edi]._msg
				push	edi
				lea	edx,wsaerr4
				call	copyedx
				invoke	WSAGetLastError
				call	itoa
				lea	edx,wsaerrr
				call	copyedx
				mov	ax,0a0dh
				stosw
				mov	al,0
				stosb
				pop	edx
				call	showmsg
				pop	edi
				invoke	closesocket,[edi].hSocket
				.if rdelay
					invoke	Sleep,rdelay
				.endif
				jmp	_artr
			.else
				push	edi
				lea	edi,[edi]._msg
				push	edi
				lea	edx,wsaerr4
				call	copyedx
				invoke	WSAGetLastError
				call	itoa
				lea	edx,wsaerra
				call	copyedx
				mov	ax,0a0dh
				stosw
				mov	al,0
				stosb
				pop	edx
				call	showmsg
				pop	edi
				invoke	closesocket,[edi].hSocket
				mov	edi,_edi
				ret
			.endif
		.endif
		.if (edi==rbuf)&&(hfile==0)
			mov	ecx,dword ptr[edi]
			or	ecx,20202020h
			.if ecx=='ptth'
				mov	byte ptr[edi+eax],0
				push	eax
				push	edi
				lea	ecx,[edi+4]
				sub	eax,4
				.while byte ptr[ecx]>33
					inc	ecx
					dec	eax
				.endw
				.while byte ptr[ecx]==32
					inc	ecx
					dec	eax
				.endw
				.if byte ptr[ecx]=='3'
					.if eax&80000000h
						xor	eax,eax
					.endif
					mov	edi,ecx
					.while eax
						.if word ptr[edi]==0a0dh
							mov	edx,dword ptr[edi+2]
							or	edx,20202020h
							.if edx=='acol'
								mov	edx,dword ptr[edi+2+4]
								or	edx,20202020h
								.if edx=='noit'
									lea	edx,[edi+2+4+4]
									.while (byte ptr[edx]==':')||(byte ptr[edx]==32)
										inc	edx
									.endw
									mov	edi,lParam
									push	edi
									lea	edi,[edi]._addr
									xor	ecx,ecx
									push	edi
									.if (byte ptr[edx]=='/')
										push	edx
										push	edi
										mov	edi,[esp+4+4+4+4+4+4]
										lea	edx,[edi]._dns
										pop	edi
										mov	eax,'ptth'
										stosd
										mov	eax,'//:'
										stosd
										dec	edi
										call	copyedx
										pop	edx
									.endif
									.while (byte ptr[edx]>32)&&(ecx<8191)
										mov	al,[edx]
										stosb
										inc	edx
										inc	ecx
									.endw
									mov	al,0
									stosb
									mov	edi,[esp+4+4+4+4]
									invoke	closesocket,[edi].hSocket
									lea	edi,[edi]._msg
									push	edi
									lea	edx,httpe3
									call	copyedx
									mov	edx,[esp+4]
									call	copyedx
									mov	ax,0a0dh
									stosw
									mov	al,0
									stosb
									pop	edx
									call	showmsg
									pop	edx
									mov	edi,lParam

									invoke	get_afile,rbuf,_edi,isimg
									mov	_edi,edi
									pop	edi
									pop	eax
									pop	edi
									mov	edi,_edi
									ret
								.endif
							.endif
						.endif
						dec	eax
						inc	edi
					.endw
				.elseif byte ptr[ecx]=='5'
					mov	edx,ecx
					pop	edi
					pop	eax
					pop	edi
					push	edi
					lea	edi,[edi]._msg
					push	edi
					push	edx
					lea	edx,httpe1
					call	copyedx
					pop	edx
					xor	ecx,ecx
					.while (ecx<200)&&(byte ptr[edx]>31)
						mov	al,[edx]
						stosb
						inc	edx
						inc	ecx
					.endw
					mov	ax,0a0dh
					stosw
					mov	al,0
					stosb
					pop	edx
					call	showmsg
					pop	edi
					invoke	closesocket,[edi].hSocket
					mov	edi,_edi
					ret
				.elseif byte ptr[ecx]=='4'
					pop	edi
					pop	eax
					pop	edi
					lea	edx,httpe2
					call	showmsg
					invoke	closesocket,[edi].hSocket
					mov	edi,_edi
					ret
				.else
					mov	edi,ecx
					.if eax&80000000h
						xor	eax,eax
					.endif
					push	edx
					.while eax
						.if word ptr[edi]==0a0dh
							mov	edx,dword ptr[edi+2]
							or	edx,20202020h
							.if edx=='tnoc'
								mov	edx,dword ptr[edi+2+4]
								or	edx,202020h
								.if edx=='-tne'
									mov	edx,dword ptr[edi+2+4+4]
									or	edx,202020h
									.if edx=='gnel'
										lea	edx,[edi+2+4+4+4+2]
										.while (byte ptr[edx]==':')||(byte ptr[edx]==32)
											inc	edx
										.endw
										push	eax
										push	esi
										mov	esi,edx
										call	atoi
										pop	esi
										mov	maxfsize,eax
										pop	eax
									.elseif edx=='psid'
										lea	edx,[edi+2+4+4+4+2]
										.while (byte ptr[edx]>31)&&(word ptr[edx]!='"=')
											inc	edx
										.endw
										.if byte ptr[edx]=='='
											lea	edx,[edx+2]
											push	edi
											mov	edi,lParam
											push	eax
											lea	edi,[edi]._file
											.while (byte ptr[edx]!='"')&&(byte ptr[edx]>31)
												mov	al,[edx]
												stosb
												inc	edx
											.endw
											mov	al,0
											stosb
											pop	eax
											pop	edi
										.endif
									.endif
								.endif
							.endif
						.endif
						inc	edi
						dec	eax
					.endw
					pop	edx
				.endif
				pop	edi
				pop	eax
				push	esi
				add	edi,eax
				mov	eax,edi
				sub	eax,rbuf
				mov	fsize,eax
				mov	ecx,eax
				mov	edi,rbuf
				mov	esi,edi
				.while ecx
					.break .if dword ptr[esi]==0a0d0a0dh
					inc	esi
					dec	ecx
				.endw
				.if (dword ptr[esi]==0a0d0a0dh)&&(ecx>=4)
					lea	esi,[esi+4]
					lea	ecx,[ecx-4]
				.endif
				mov	fsize,ecx
				.if ecx
					rep	movsb
				.endif
				pop	esi
			.else
				.if eax>100000h
					int 3
				.endif
				add	edi,eax
				add	fsize,eax
			.endif
		.else
			.if eax>100000h
				int 3
			.endif
			add	edi,eax
			add	fsize,eax
		.endif
		.if (fsize!=0)
			.if (hfile==0)
				mov	ebx,[esp]
				assume	ebx:ptr foruminfo
				lea	edi,[ebx]._save
				lea	edx,defdir
				mov	ecx,edi
				.while byte ptr[edx]!=0
					mov	al,[edx]
					.if al=='\'
						mov	ecx,edi
					.endif
					stosb
					inc	edx
				.endw
				mov	edi,ecx
				mov	al,'\'
				stosb
				mov	eax,diridx
				push	ebx
				call	w5
				pop	ebx
				mov	al,32
				stosb
				lea	edx,[ebx]._addr
				mov	ecx,edx
				.while byte ptr[edx]
					.if (byte ptr[edx]=='/')&&(byte ptr[edx+1]!=0)
						lea	ecx,[edx+1]
					.endif
					inc	edx
				.endw
				mov	esi,ecx
				.if byte ptr[ebx]._file
					lea	esi,[ebx]._file
				.endif
				call	escfile1
				mov	al,0
				stosb
				xor	eax,eax
				.if isimg
					mov	edx,rbuf
					.while (byte ptr[edx]==32)||(byte ptr[edx]==9)||(byte ptr[edx]==13)||(byte ptr[edx]==10)
						inc	edx
					.endw
					.if byte ptr[edx]!='<'
						inc	eax
					.endif
				.else
					inc	eax
				.endif
				mov	edi,_edi
				.if eax
					lea	edx,[ebx]._save
					invoke	CreateFile,edx,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
					mov	hfile,eax
					mov	edx,eax
					mov	ebx,lParam
					invoke	WriteFile,edx,rbuf,fsize,addr _edi,0
					mov	eax,diridx
					mov	ebx,lParam
					lea	edx,[ebx]._save
					mov	ecx,edx
					.while byte ptr[edx]
						.if byte ptr[edx]=='\'
							lea	ecx,[edx+1]
						.endif
						inc	edx
					.endw
					mov	edx,ecx
					call	copyedx
				.else
					push	edi
					lea	edx,errd2
					call	copyedx
					lea	edx,[ebx]._addr
					mov	eax,[edx]
					or	eax,20202020h
					.if eax!='ptth'
						mov	eax,'ptth'
						stosd
						mov	eax,'//:'
						stosd
						dec	edi
					.endif
					call	copyedx
					lea	edx,errd2a
					call	copyedx
					mov	al,0
					stosb
					pop	edx
					push	edx
					call	showmsg
					pop	edi
					mov	edi,rbuf
					.break
				.endif
				mov	_edi,edi
				assume	ebx:nothing
			.else
				invoke	WriteFile,hfile,rbuf,eax,addr bread,0
			.endif
		.endif
	.endw
	pop	edi
	.if fsize==0
		mov	ebx,edi
		push	ebx
		mov	edi,rbuf
		assume	ebx:ptr foruminfo
		push	edi
		lea	edx,errd1
		call	copyedx
		lea	edx,[ebx]._addr
		mov	eax,[edx]
		or	eax,20202020h
		.if eax!='ptth'
			mov	eax,'ptth'
			stosd
			mov	eax,'//:'
			stosd
			dec	edi
		.endif
		call	copyedx
		mov	eax,0a0dh
		stosd
		pop	edx
		push	edx
		call	showmsg
		pop	edi
		assume	ebx:nothing
		pop	edi
	.else
		push	edi
		lea	edx,[edi]._addr
		lea	edi,[edi]._msg
		push	edi
		push	edx
		lea	edx,wsad
		call	copyedx
		pop	edx
		push	edi
		mov	edi,[esp+8]
		mov	eax,fsize
		pop	edi
		call	itoa
		lea	edx,wsab
		call	copyedx
		mov	ax,0a0dh
		stosw
		mov	al,0
		stosb
		pop	edx
		call	showmsg
		pop	edi
	.endif
	.if hfile
		invoke	CloseHandle,hfile
	.endif
	invoke	closesocket,[edi].hSocket
	mov	edi,_edi
	ret
get_afile	ENDP

wrfile	db	'* Writing file ',0
msgovr	db	'- The file ',0
msgovr1	db	' already exists, overwriting...',13,10,0
msgerrf	db	'[ X ] Error creating file ',0
filesizeerr db	'[ X ] File size exceeds ',0
filesizeerr1 db	' bytes, aborting...',0
wfile:	push	edi
	push	edx
	lea	edi,fdir
	lea	edx,defdir
	.while byte ptr[edx]
		mov	al,[edx]
		.if al=='/'
			mov	al,'\'
		.endif
		stosb
		inc	edx
	.endw
	.if edx!=offset defdir
		.if byte ptr[edi-1]!='\'
			mov	al,'\'
			stosb
		.endif
	.endif
	pop	edx
	call	copyedx
	mov	al,0
	stosb
	lea	edi,buftmp
	lea	edx,wrfile
	call	copyedx
	lea	edx,fdir
	call	copyedx
	mov	eax,'... '
	stosd
	mov	ax,0a0dh
	stosw
	mov	al,0
	stosb
	lea	edx,buftmp
	call	showmsg
	invoke	GetFileAttributes,addr fdir
	.if eax!=-1
		lea	edi,buftmp
		lea	edx,msgovr
		call	copyedx
		lea	edx,fdir
		call	copyedx
		lea	edx,msgovr1
		call	copyedx
		mov	al,0
		stosb
		lea	edx,buftmp
		call	showmsg
		invoke	SetFileAttributes,addr fdir,0
		invoke	DeleteFile,addr fdir
	.endif
	invoke	CreateFile,addr fdir,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0
	.if eax==INVALID_HANDLE_VALUE
		lea	edx,msgerrf
		lea	edi,buftmp
		call	copyedx
		lea	edx,fdir
		call	copyedx
		mov	ax,0a0dh
		stosw
		mov	al,0
		stosb
		lea	edx,buftmp
		call	showmsg
	.else
		push	eax
		invoke	WriteFile,eax,addr recvbuf,fsize,addr bread,0
		call	CloseHandle
	.endif
	pop	edi
	ret

showmsg:
	push	edx
	invoke	SendDlgItemMessage,hDialog,200,WM_GETTEXTLENGTH,0,0
	pop	edx
	push	edx
	xor	ecx,ecx
	.while byte ptr[edx+ecx]
		inc	ecx
	.endw
	push	ecx
	add	ecx,eax
	.if ecx>32768
		invoke	SendDlgItemMessage,hDialog,200,EM_SETSEL,0,16384
		pop	ecx
		pop	edx
		push	edx
		push	ecx
		lea	ecx,[edx+ecx]
		invoke	SendDlgItemMessage,hDialog,200,EM_REPLACESEL,0,ecx
		invoke	SendDlgItemMessage,hDialog,200,WM_GETTEXTLENGTH,0,0
	.endif
	invoke	SendDlgItemMessage,hDialog,200,EM_SETSEL,eax,eax
	mov	edx,[esp+4]
	invoke	SendDlgItemMessage,hDialog,200,EM_REPLACESEL,0,edx
	.if lsave
		invoke	CreateFile,addr logfile,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_ALWAYS,0,0
		push	eax
		invoke	SetFilePointer,eax,0,0,FILE_END
		pop	eax
		mov	edx,[esp+4]
		push	eax
		xor	ecx,ecx
		.while byte ptr[edx+ecx]
			inc	ecx
		.endw
		invoke	WriteFile,eax,edx,ecx,addr bread,0
		call	CloseHandle
	.endif
	.if started==2
		invoke	SendDlgItemMessage,hDialog,200,WM_GETTEXTLENGTH,0,0
		invoke	SendDlgItemMessage,hDialog,200,EM_SETSEL,eax,eax
		invoke	SendDlgItemMessage,hDialog,200,EM_REPLACESEL,0,addr _pause
	.endif
	.while started==2
		invoke	Sleep,100
	.endw
	pop	ecx
	pop	edx
	ret
assume	edi:nothing

end	start